## elektra-0.8.0.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

project (Elektra)

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
	if (NOT FORCE_IN_SOURCE_BUILD)
		message(FATAL_ERROR
				"In-source builds are not permitted.\n"
				"Make a separate folder for building:\n"
				"    mkdir build && cd build && cmake ..\n"
				"Before that, remove the files already created:\n"
				"    rm -rf CMakeCache.txt CMakeFiles\n"
				"If you really know what you are doing\n"
				"(will overwrite original files!) use:\n"
				"    cmake -DFORCE_IN_SOURCE_BUILD=ON\n"
			)
	endif (NOT FORCE_IN_SOURCE_BUILD)
endif(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)

if (ENABLE_TESTING)
	enable_testing ()
	include (Dart)
endif (ENABLE_TESTING)

#additional modules for loading libraries
set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")

if (NOT CMAKE_BUILD_TYPE)
	SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif (NOT CMAKE_BUILD_TYPE)

set (DOMAIN libelektra.org)
set (REVERSE_DOMAIN org.libelektra)

set (KDB_VERSION_MAJOR 0)
set (KDB_VERSION_MINOR 8)
set (KDB_VERSION_MICRO 0)

set (KDB_VERSION "${KDB_VERSION_MAJOR}.${KDB_VERSION_MINOR}.${KDB_VERSION_MICRO}")
set (KDB_VERSION_MAJORMINOR "${KDB_VERSION_MAJOR}.${KDB_VERSION_MINOR}")

set (SO_VERSION 4)

include (cmake/ElektraPackaging.cmake)
include (cmake/ElektraCache.cmake)
include (cmake/ElektraCompiling.cmake)

add_subdirectory (src)
add_subdirectory (cmake)

if (BUILD_DOCUMENTATION)
	add_subdirectory (doc)
endif (BUILD_DOCUMENTATION)

if (BUILD_TESTING)
	if (BUILD_FULL OR BUILD_STATIC)
		add_subdirectory (tests)
	endif (BUILD_FULL OR BUILD_STATIC)
endif (BUILD_TESTING)

if (BUILD_FULL OR BUILD_STATIC)
	if (BUILD_EXAMPLES)
		add_subdirectory (examples)
	endif (BUILD_EXAMPLES)
endif (BUILD_FULL OR BUILD_STATIC)

if (BUILD_FULL OR BUILD_STATIC)
	add_subdirectory (benchmarks EXCLUDE_FROM_ALL)
endif (BUILD_FULL OR BUILD_STATIC)

ADD_CUSTOM_TARGET(uninstall
	"${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_SOURCE_DIR}/cmake/ElektraUninstall.cmake")

ADD_CUSTOM_TARGET(source-package
		COMMAND git-tag ${KDB_VERSION} && git-archive --prefix=elektra-${KDB_VERSION}/ --format=tar ${KDB_VERSION} | gzip > ${CMAKE_BINARY_DIR}/elektra-${KDB_VERSION}.tar.gz
		COMMENT Make a elektra source package by using git VERBATIM
		WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
		)

=== cmake/CMakeLists.txt ===
get_filename_component(ELEKTRA_INSTALL_LIBRARY
		ELEKTRA_LIBRARY NAME
		)

set (ELEKTRA_LIBRARY ${CMAKE_INSTALL_PREFIX}/lib/${ELEKTRA_INSTALL_LIBRARY})
set (ELEKTRA_INCLUDE ${CMAKE_INSTALL_PREFIX}/include)

#configure_file (
#		"${PROJECT_SOURCE_DIR}/cmake/ElektraConfig.cmake.in"
#		"${PROJECT_BINARY_DIR}/cmake/ElektraConfig.cmake"
#		@ONLY
#	       )
#
#include (CMakeExportBuildSettings)
#
#cmake_export_build_settings (
#		${PROJECT_BINARY_DIR}/cmake/ElektraBuildSettings.cmake
#		)
#
#export_library_dependencies (
#		${PROJECT_BINARY_DIR}/cmake/ElektraLibraryDepends.cmake
#		)


#because above configuring in fact does not work, provide a simple
#find package which should be enough for the moment
configure_file (
		"${CMAKE_CURRENT_SOURCE_DIR}/FindElektra.cmake.in"
		"${CMAKE_CURRENT_BINARY_DIR}/FindElektra.cmake"
		@ONLY
	)

# Install the packaging files for use by find_package
install ( FILES
#		${PROJECT_SOURCE_DIR}/cmake/ElektraUse.cmake
#		${PROJECT_BINARY_DIR}/cmake/ElektraConfig.cmake
#		${PROJECT_BINARY_DIR}/cmake/ElektraBuildSettings.cmake
#		${PROJECT_BINARY_DIR}/cmake/ElektraLibraryDepends.cmake
		"${CMAKE_CURRENT_BINARY_DIR}/FindElektra.cmake"
		DESTINATION ${CMAKE_DESTINATION}
	)

configure_file (
		"${CMAKE_CURRENT_SOURCE_DIR}/elektra.pc.in"
		"${CMAKE_CURRENT_BINARY_DIR}/elektra.pc"
		@ONLY
	)

install ( FILES
		"${CMAKE_CURRENT_BINARY_DIR}/elektra.pc"
		DESTINATION ${PKGCONFIG_DESTINATION}
	)

=== doc/CMakeLists.txt ===
find_package(Doxygen)

# do_doc
#
#name is man, html or latex
#builds and install documentation
macro (do_doc target file)
	add_custom_command (
		OUTPUT ${target}/${file}
		COMMAND ${DOXYGEN_EXECUTABLE}
		ARGS ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
		DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
	)

	get_filename_component (name ${target} NAME_WE)

	add_custom_target (${name} ALL
		DEPENDS ${target}/${file}
	)

	if (INSTALL_DOCUMENTATION)
		install (
			DIRECTORY ${target}
			DESTINATION ${DOCUMENTATION_DESTINATION}
		)
	endif (INSTALL_DOCUMENTATION)
endmacro (do_doc)

if (DOXYGEN_FOUND)
	set (OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

	find_package(LATEX)

	if (LATEX_COMPILER)
		set (WITH_LATEX YES)
	else (LATEX_COMPILER)
		set (WITH_LATEX NO)
	endif (LATEX_COMPILER)

	if (DOXYGEN_DOT_FOUND)
		set (WITH_DOT YES)
	else (DOXYGEN_DOT_FOUND)
		set (WITH_DOT NO)
	endif (DOXYGEN_DOT_FOUND)

	find_package(Perl)

	configure_file (
		"${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile"
		"${CMAKE_CURRENT_BINARY_DIR}/Doxyfile"
		@ONLY
	)

	do_doc(${OUTPUT_DIRECTORY}/html index.html)
	do_doc(${OUTPUT_DIRECTORY}/man man3/kdb.3)

	if (LATEX_COMPILER)
		do_doc(${OUTPUT_DIRECTORY}/latex refman.tex)

		add_custom_command (
			OUTPUT ${OUTPUT_DIRECTORY}/latex/refman.pdf
			COMMAND ${PDFLATEX_COMPILER}
			ARGS ${OUTPUT_DIRECTORY}/latex/refman.tex
			DEPENDS ${OUTPUT_DIRECTORY}/latex/refman.tex
			WORKING_DIRECTORY ${OUTPUT_DIRECTORY}/latex/
		)

		add_custom_target (pdf ALL
			DEPENDS ${OUTPUT_DIRECTORY}/latex/refman.pdf
		)
	endif (LATEX_COMPILER)
else (DOXYGEN_FOUND)
	message (STATUS "Warning, Doxygen not found, Reference Manual can't be created. But it was requested to do so.")
endif (DOXYGEN_FOUND)

=== src/CMakeLists.txt ===
add_subdirectory (include)

add_subdirectory (error)

add_subdirectory (libloader)

add_subdirectory (plugins)

add_subdirectory (libelektra)

add_subdirectory (bindings)

add_subdirectory (kdb)

=== src/bindings/CMakeLists.txt ===
add_subdirectory (cpp)

=== src/include/CMakeLists.txt ===
set(DISCLAMER "
/***************************************************************************
 *                                                                         *
 * This header file is AUTO GENERATED.                                     *
 * Do not edit this file, otherwise your changes will be discarded in the  *
 * next cmake run.                                                         *
 *                                                                         *
 ***************************************************************************/")

configure_file (
	"${CMAKE_CURRENT_SOURCE_DIR}/kdb.h"
	"${CMAKE_CURRENT_BINARY_DIR}/kdb.h"
	)

configure_file (
	"${CMAKE_CURRENT_SOURCE_DIR}/kdbvar.h"
	"${CMAKE_CURRENT_BINARY_DIR}/kdbvar.h"
	)

configure_file (
	"${CMAKE_CURRENT_SOURCE_DIR}/kdbconfig.h"
	"${CMAKE_CURRENT_BINARY_DIR}/kdbconfig.h"
	)

configure_file (
	"${CMAKE_CURRENT_SOURCE_DIR}/kdbversion.h"
	"${CMAKE_CURRENT_BINARY_DIR}/kdbversion.h"
	)

install (FILES
	"${CMAKE_CURRENT_BINARY_DIR}/kdbconfig.h"
	kdbextension.h
	"${CMAKE_CURRENT_BINARY_DIR}/kdb.h"
	kdbinternal.h
	kdbmodule.h
	kdbos.h
	kdbplugin.h
	kdbprivate.h
	kdbtools.h
	"${CMAKE_CURRENT_BINARY_DIR}/kdbvar.h"
	"${CMAKE_CURRENT_BINARY_DIR}/kdbversion.h"
	DESTINATION include/elektra)

=== src/libelektra/CMakeLists.txt ===
# For static inclusion of libraries we need a list
# of symbols to make the static runtime linker work.
#
# For that there is the program exportsymbols which
# generates the sourcefiles exported_symbols.h
# and exported_symbols.c containing an array of
# all symbols.
#
# The program needs a list of all backends as
# argument.
#
# Symbols of libelektratools will be treaded specially.
add_executable (exportsymbols exportsymbols.c)

if (CMAKE_CROSSCOMPILING)
	find_program (EXE_SYM_LOC exportsymbols)
else (CMAKE_CROSSCOMPILING)
	get_target_property (EXE_SYM_LOC exportsymbols LOCATION)
endif (CMAKE_CROSSCOMPILING)

add_custom_command (
		OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/exported_symbols.h
		DEPENDS exportsymbols
		COMMAND ${EXE_SYM_LOC}
		ARGS ${PLUGINS}
		)

add_custom_command (
		OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/exported_symbols.c
		DEPENDS exportsymbols
		COMMAND ${EXE_SYM_LOC}
		ARGS ${PLUGINS}
		)


# Include the shared header files of the elektra project
include(LibAddMacros)
add_headers(HDR_FILES)
# not always needed.. only with cppplugins
add_cppheaders(HDR_FILES)

#include the current binary directory to get exported_symbols.h
include_directories("${CMAKE_CURRENT_BINARY_DIR}")

#now add all source files of this folder
file (GLOB SRC_FILES *.c)

#remove those we don't want..
file (GLOB RM_FILES exportsymbols.c kdbmainpage.c)
list (REMOVE_ITEM SRC_FILES ${RM_FILES})

#now add all source files of other folders
get_property (elektra_SRCS GLOBAL PROPERTY elektra_SRCS)
list (APPEND SRC_FILES ${elektra_SRCS})

set (SOURCES ${SRC_FILES} ${HDR_FILES})
list (APPEND SOURCES "${CMAKE_CURRENT_BINARY_DIR}/exported_symbols.h")


if (BUILD_SHARED)
	get_property (elektra-shared_SRCS GLOBAL PROPERTY elektra-shared_SRCS)
	add_library (elektra SHARED ${SOURCES} ${elektra-shared_SRCS})

	get_property (elektra-shared_LIBRARIES GLOBAL PROPERTY elektra-shared_LIBRARIES)
	target_link_libraries (elektra ${elektra-shared_LIBRARIES})

	get_property (elektra-shared_INCLUDES GLOBAL PROPERTY elektra-shared_INCLUDES)
	include_directories (${elektra-shared_INCLUDES})

	set_target_properties (elektra PROPERTIES
			COMPILE_DEFINITIONS HAVE_KDBCONFIG_H)
	set_target_properties (elektra PROPERTIES
			VERSION ${KDB_VERSION} SOVERSION ${SO_VERSION})
	set_target_properties (elektra PROPERTIES CLEAN_DIRECT_OUTPUT 1)

	#RPATH settings, see http://www.itk.org/Wiki/CMake_RPATH_handling
	set_target_properties (elektra PROPERTIES
			INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib/elektra:/usr/lib/elektra:/lib/elektra")

	install (TARGETS elektra DESTINATION lib)
endif (BUILD_SHARED)

if (BUILD_FULL OR BUILD_STATIC)
	#for the next two builds, append some more sources
	get_property (elektra-full_SRCS GLOBAL PROPERTY elektra-full_SRCS)
	list (APPEND SOURCES ${elektra-full_SRCS})
	list (APPEND SOURCES "${CMAKE_CURRENT_BINARY_DIR}/exported_symbols.c")

	#and get all libraries to link against
	get_property (elektra-full_LIBRARIES GLOBAL PROPERTY elektra-full_LIBRARIES)

	# include the directories of all libraries for the static or
	# full-shared build
	get_property (elektra-full_INCLUDES GLOBAL PROPERTY elektra-full_INCLUDES)

	include_directories (${elektra-full_INCLUDES})
endif (BUILD_FULL OR BUILD_STATIC)


if (BUILD_FULL)
	add_library (elektra-full SHARED ${SOURCES})

	target_link_libraries (elektra-full ${elektra-full_LIBRARIES})

	set_target_properties (elektra-full PROPERTIES
			COMPILE_DEFINITIONS "HAVE_KDBCONFIG_H;ELEKTRA_STATIC")
	set_target_properties (elektra-full PROPERTIES
			VERSION ${KDB_VERSION} SOVERSION ${SO_VERSION})
	set_target_properties (elektra-full PROPERTIES CLEAN_DIRECT_OUTPUT 1)
	set_target_properties (elektra-full PROPERTIES LINKER_LANGUAGE CXX)

	install (TARGETS elektra-full DESTINATION lib)
endif (BUILD_FULL)


if (BUILD_STATIC)
	add_library (elektra-static STATIC ${SOURCES})

	target_link_libraries (elektra-static ${elektra-full_LIBRARIES})

	set_target_properties (elektra-static PROPERTIES
			COMPILE_DEFINITIONS "HAVE_KDBCONFIG_H;ELEKTRA_STATIC")
	set_target_properties (elektra-static PROPERTIES
			VERSION ${KDB_VERSION} SOVERSION ${SO_VERSION})
	set_target_properties (elektra-static PROPERTIES CLEAN_DIRECT_OUTPUT 1)
	set_target_properties (elektra-static PROPERTIES LINKER_LANGUAGE CXX)

	install (TARGETS elektra-static DESTINATION lib)
endif (BUILD_STATIC)

#if you want the same name for those 3 libraries, here is how to do it:
#http://www.itk.org/Wiki/CMake_FAQ#How_do_I_make_my_shared_and_static_libraries_have_the_same_root_name.2C_but_different_suffixes.3F

=== src/plugins/CMakeLists.txt ===
foreach (plugin ${PLUGINS})
	message("-- Include Plugin ${plugin}")
	add_subdirectory ("${plugin}")
endforeach(plugin)

#symlink for default plugin?
#list (FIND BACKENDS ${BACKEND_DEFAULT} output)
#if (output GREATER -1)
#	mkdir (${CMAKE_BINARY_DIR}/dist/lib/elektra)
#	create_symlink (
#			libelektra-${BACKEND_DEFAULT}.so
#			${CMAKE_BINARY_DIR}/dist/lib/elektra/libelektra-default.so
#			)
#	message ("-- Default backend: ${BACKEND_DEFAULT}")
#else (output GREATER -1)
#	message (SEND_ERROR "default backend ${BACKEND_DEFAULT} is not included")
#endif (output GREATER -1)

#install (DIRECTORY ${CMAKE_BINARY_DIR}/dist/lib/elektra DESTINATION lib)

=== src/plugins/ccode/CMakeLists.txt ===
include (LibAddMacros)

set (SOURCES ccode.h ccode.c)
add_sources (elektra-full ${SOURCES})
add_headers (SOURCES)

add_library (elektra-ccode MODULE ${SOURCES})
install (TARGETS elektra-ccode DESTINATION lib/elektra)

add_plugintest (ccode)

=== src/plugins/dbus/CMakeLists.txt ===
find_package(DBus REQUIRED)
if (DBUS_FOUND)
	include (LibAddMacros)

	add_includes (elektra-full ${DBUS_INCLUDE_DIR})
	add_includes (elektra-full ${DBUS_ARCH_INCLUDE_DIR})
	include_directories (${DBUS_INCLUDE_DIR})
	include_directories (${DBUS_ARCH_INCLUDE_DIR})

	set (SOURCES dbus.h dbus.c sendmessage.c receivemessage.c)
	add_sources (elektra-full ${SOURCES})
	add_headers (SOURCES)

	add_library (elektra-dbus MODULE ${SOURCES})
	install (TARGETS elektra-dbus DESTINATION lib/elektra)

	target_link_libraries (elektra-dbus ${DBUS_LIBRARIES})
	add_libraries(elektra-full ${DBUS_LIBRARIES})

	add_plugintest (dbus)
else (DBUS_FOUND)
	remove_plugin (dbus "dbus not found")
endif (DBUS_FOUND)

=== src/plugins/doc/CMakeLists.txt ===
include(LibAddMacros)

set (SOURCES doc.c)
add_sources(elektra-full ${SOURCES})
add_headers(SOURCES)

add_library(elektra-doc MODULE ${SOURCES})
install (TARGETS elektra-doc DESTINATION lib/elektra)

=== src/plugins/dump/CMakeLists.txt ===
include(LibAddMacros)

set (SOURCES dump.hpp dump.cpp)
add_sources(elektra-full ${SOURCES})
add_headers(SOURCES)

add_library(elektra-dump MODULE ${SOURCES})
install (TARGETS elektra-dump DESTINATION lib/elektra)

add_plugintest(dump)

=== debian/changelog ===
elektra (0.8.0-1) unstable; urgency=low

  * New upstream version.

 -- Markus Raab <debian@markus-raab.org>  Fri, 04 May 2012 14:31:28 +0200

elektra (0.8.0rc5-1) unstable; urgency=low

  * New upstream version.

 -- Markus Raab <debian@markus-raab.org>  Fri, 04 May 2012 09:36:29 +0200

elektra (0.8.0rc4-1) unstable; urgency=low

  * New upstream version.

 -- Markus Raab <debian@markus-raab.org>  Thu, 03 May 2012 10:00:46 +0200

elektra (0.8.0rc3-1) unstable; urgency=low

  * New upstream version.

 -- Markus Raab <debian@markus-raab.org>  Tue, 01 May 2012 23:15:48 +0200

elektra (0.8.0rc1-1) unstable; urgency=low

  * Elektra 0.8.0 repackaging

 -- Markus Raab <elektra@markus-raab.org>  Thu, 05 Apr 2012 19:01:05 +0200

elektra (0.8.0rc0-1) unstable; urgency=low

  * Elektra 0.8.0 packaging with cmake

 -- Markus Raab <elektra@markus-raab.org>  Wed, 22 Feb 2012 16:42:02 +0100

elektra (0.7.0a1-1) unstable; urgency=low

  * New upstream version.
  * Repackaged using CDBS.
  * Removed menu file, as it makes little sense for kdb(1).

 -- Andreas Rottmann <rotty@debian.org>  Thu, 22 Mar 2007 13:32:59 +0100

elektra (0.5) unstable; urgency=low

  * Split to bin and dev packages.

 -- Pier Luigi Fiorini <pierluigi.fiorini@mockup.org>  Mon, 25 Apr 2005 19:44:10 +0200

elektra (0.4.11-5) unstable; urgency=low

  * Update to 0.4.11-5

 -- Markus Raab <debian@markus-raab.rog>  Fri, 25 Mar 2005 09:35:14 +0100
 

elektra (0.4.7-2) unstable; urgency=low

  * Sarge Integrate and Update to 0.4.7

 -- Markus Raab <markus@superbyte.at>  Thu, 05 Dec 2004 12:55:10 +0200

elektra (0.4.4-2) unstable; urgency=low

  * Updated to current Version

 -- Markus Raab <markus@superbyte.at>  Thu, 23 Sep 2004 12:55:10 +0200

elektra (0.4.4-1) unstable; urgency=low

  * Some Updates

 -- Markus Raab <markus@superbyte.at>  Thu, 23 Sep 2004 12:55:10 +0200

elektra (0.4.2-1) unstable; urgency=low

  * Initial Release.

 -- Markus Raab <markus@superbyte.at>  Thu, 23 Sep 2004 12:55:10 +0200

=== debian/control ===
Source: elektra
Priority: required
Maintainer: Simon Law <sfllaw@debian.org>
Uploaders: Pier Luigi Fiorini <pierluigi.fiorini@mockup.org>
Build-Depends: debhelper (>= 4.1.0), libxml2-dev, doxygen, libboost-dev, cmake
Standards-Version: 3.7.2
Section: base

Package: libelektra-dev
Section: libdevel
Architecture: any
Depends: libelektra2 (= ${Source-Version}), libc6-dev
Description: a framework to get system and user values
 The objective of the Elektra Project is to help create a pervasive, 
 ubiquitous configuration system. This is an entire ecosystem, much
 more than a piece of code. This section lists the work of some 
 people that are helping to build it.
 .
 This package contains the files needed to compile and link
 programs which use Elektra.

Package: libelektra2
Section: libs
Architecture: any
Depends: ${shlibs:Depends}
Description: a framework to get system and user values
 The objective of the Elektra Project is to help create a pervasive, 
 ubiquitous configuration system. This is an entire ecosystem, much
 more than a piece of code. This section lists the work of some 
 people that are helping to build it.

Package: libelektra-bin
Section: admin
Architecture: any
Depends: ${shlibs:Depends}
Description: binaries for libelektra2
 The objective of the Elektra Project is to help create a pervasive, 
 ubiquitous configuration system. This is an entire ecosystem, much
 more than a piece of code. This section lists the work of some 
 people that are helping to build it.
 .
 This package contains the Elektra kdb program and man pages.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# Make sure libelektra2 is built before packages depending on it
binary/libelektra-bin binary/libelektra-dev:: binary/libelektra2

install/libelektra-bin::
	install -m 644 debian/kdb.1 debian/tmp/usr/share/man/man1

CMAKE_FLAGS = \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DPLUGINS="dump;resolver;ccode;hosts;syslog;tracer;error;fstab;network;null;path;simpleini;success;tcl;timeofday;type;xmltool" \
	-DKDB_DB_SYSTEM=/etc/kdb \
	-DKDB_DB_HOME=/home \
	-DKDB_DB_USER=.kdb \
	-DBUILD_FULL=OFF
#"dump;resolver;hidden;iconv;syslog;error;validation;xmltool;tracer;timeofday;dbus;glob;hosts;network;type;struct;path;fstab;ccode;simplei;ni;tcl;hexcode;null;ni"

%:
	dh $@ --buildsystem=cmake --parallel

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)

override_dh_auto_test:

override_dh_installdocs:
